//
//  TOAJustOutVideoRenderer.h
//  TOAJustOutVideoRenderer
//
//  Created by David Lincoln on 24/06/15.
//  Copyright (c) 2015 Tools On Air Broadcast Engineering GmbH. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//! Project version number for TOAJustOutVideoRenderer.
FOUNDATION_EXPORT double TOAJustOutVideoRendererVersionNumber;

//! Project version string for TOAJustOutVideoRenderer.
FOUNDATION_EXPORT const unsigned char TOAJustOutVideoRendererVersionString[];

// In this header, you should import all the public headers of your framework using statements like #import <TOAJustOutVideoRenderer/PublicHeader.h>

typedef enum {
    TOAJustOutVideoRendererColorSpace_REC601,
    TOAJustOutVideoRendererColorSpace_REC709,
    
} TOAVideoRendererColorSpace;

typedef enum {
    TOAJustOutVideoRendererMode_Progressive,
    TOAJustOutVideoRendererMode_InterlacedEven,
    TOAJustOutVideoRendererMode_InterlacedOdd,

} TOAJustOutVideoRendererMode;

@interface TOAJustOutVideoRenderer : NSObject {
    CGLContextObj   cgl_ctx;
    GLuint          programs[2];
    GLint           spaceLocs[2];
    GLint           fieldOffsetLoc;
    GLint           textureHeightLoc;
    int             currentColorSpace;
    int             requestedColorSpace;
}

-(BOOL) createWithContext:(CGLContextObj)ctx textureType:(GLenum)textureType;
-(void) cleanUp;
-(void) setColorSpace:(TOAVideoRendererColorSpace)space;
-(void) guessColorSpaceFromAttributes:(NSDictionary*)attributes;
-(void) beforeRenderWithMode:(TOAJustOutVideoRendererMode)mode textureHeight:(int)textureHeight;
-(void) afterRender;

@end